# zot/plugs/irc.py
#
#

""" irc command. """

## IMPORTS

from zot.runtime import kernel, fleet

## join command

def ircjoin(event):
    channel = event.args[0]
    for bot in fleet:
        if bot.type == "irc":
            bot.join(channel)
            event.reply("join %s (%s)" % (channel, bot.server))

kernel.register("irc.join", ircjoin)

## part command

def ircpart(event):
    for bot in fleet:
        if bot.type == "irc":
            bot.part(event.args[0])
            event.reply("part %s (%s)" % (channel, bot.server))

## nick command

def ircnick(event):
    for bot in fleet:
        if bot.type == "irc":
            bot.nick(event.args[0])
            event.reply("nick %s" % bot.server)

kernel.register("irc.nick", ircpart)

## quit command

def ircquit(event):
    for bot in fleet:
        if bot.type == "irc":
            bot.quit(event.rest())
            event.reply("quit %s" % bot.server)
    
kernel.register("irc.quit", ircquit)
