# zot/runtime.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from zot.defaults import cfg_kernel
from zot.utils import make_opts, hello, error
from zot.dispatcher import DISPATCHER
from zot.defines import opts_defs
from zot.plugins import PLUGINS
from zot.object import Object
from zot.log import init

import logging
import sys
import os

def zotpath():
    for path in sys.path:
        if "zot" in path and "egg" in path: yield path  

## KERNEL

class KERNEL(PLUGINS):

    def boot(zelf, *args, **kwargs):
        opts, arglist = make_opts(opts_defs)
        cfg.update(cfg_kernel)
        cfg.update(vars(opts))
        cfg.runargs = arglist
        cfg.shell = True
        if arglist: cfg.shell = False
        if cfg.shell and args: hello(args[0])
        init(cfg.loglevel)
        if cfg.loglevel != "error":
            print("\n".join(sorted(cfg.show())))
            print("path=%s" % ", ".join(list(zotpath()))) 
            print("")
        for package in cfg.packages:
            try: mods.load(package)
            except: error()
        mods.init(cfg.init)
        zelf.ready()
        return zelf

    def shutdown(zelf, *args, **kwargs): logging.warn("shutdown")

## DEFINES

kernel = KERNEL()
mods = PLUGINS()
cfg = Object()
fleet = []
